"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _indexOf2 = _interopRequireDefault(require("lodash/indexOf"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var listeners = [];
var _default = {
  on: function on(topic, subscriber) {
    var listener = {
      topic: topic,
      subscriber: subscriber
    };
    listeners.push(listener);
    return function () {
      return listeners.pop(listener);
    };
  },
  emit: function emit(topic, data) {
    listeners.forEach(function (listener) {
      if ((0, _indexOf2.default)(topic, listener.topic) < 0) return;
      listener.subscriber(_objectSpread({
        topic: topic[0]
      }, data));
    });
  }
};
exports.default = _default;