"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _localStorage = _interopRequireDefault(require("./localStorage"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = {
  get token() {
    var value = _localStorage.default.getItem("apollo-access-token");

    if (value) return "Bearer ".concat(value);
    return "";
  },

  set token(value) {
    _localStorage.default.setItem("apollo-access-token", value);
  },

  get refreshToken() {
    return _localStorage.default.getItem("apollo-refresh-token");
  },

  set refreshToken(value) {
    _localStorage.default.setItem("apollo-refresh-token", value);
  },

  get expired() {
    return _localStorage.default.getItem("apollo-expired");
  },

  set expired(value) {
    _localStorage.default.setItem("apollo-expired", value);
  },

  apply: function apply(_ref) {
    var accessToken = _ref.accessToken,
        refreshToken = _ref.refreshToken;
    this.token = accessToken;
    this.refreshToken = refreshToken;
    this.expired = refreshToken ? Date.now() + 55 * 60 * 1000 : 0;
  }
};
exports.default = _default;