"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _assertResult2 = _interopRequireDefault(require("thelper/assertResult"));

var _random2 = _interopRequireDefault(require("lodash/random"));

var _defaults3 = _interopRequireDefault(require("lodash/defaults"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _axios = _interopRequireDefault(require("axios"));

var _urlParse = _interopRequireDefault(require("url-parse"));

var _ApolloListener = _interopRequireDefault(require("./ApolloListener"));

var _ApolloToken = _interopRequireDefault(require("./ApolloToken"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function isForbidden(e) {
  return (0, _get2.default)(e, ["response", "status"]) === 403;
}

var events = Object.freeze({
  signInResolve: ["signInResolve", "signIn", "resolve"],
  signInReject: ["signInReject", "signIn", "reject"],
  signOutResolve: ["signOutResolve", "signOut", "resolve"],
  signOutReject: ["signOutReject", "signOut", "reject"],
  changeViewerResolve: ["changeViewerResolve", "changeViewer", "resolve"],
  changeViewerReject: ["changeViewerReject", "changeViewer", "reject"],
  renewResolve: ["renewResolve", "renew", "resolve"],
  renewReject: ["renewReject", "renew", "reject"]
});

var Authenticator =
/*#__PURE__*/
function () {
  function Authenticator(options) {
    _classCallCheck(this, Authenticator);

    _defineProperty(this, "instance", null);

    var _defaults2 = (0, _defaults3.default)({}, options, {
      path: "/auth",
      params: {}
    }),
        uri = _defaults2.uri,
        headers = _defaults2.headers,
        configs = _objectWithoutProperties(_defaults2, ["uri", "headers"]);

    var url = new _urlParse.default(uri);
    this.configs = configs;
    this.instance = _axios.default.create({
      baseURL: url.origin,
      headers: headers,
      withCredentials: true
    });
  }

  _createClass(Authenticator, [{
    key: "request",
    value: function () {
      var _request = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(params) {
        var retry,
            instance,
            configs,
            result,
            _args = arguments;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                retry = _args.length > 1 && _args[1] !== undefined ? _args[1] : 3;
                _context.prev = 1;
                instance = this.instance, configs = this.configs;
                _context.next = 5;
                return instance.post(configs.path, _objectSpread({}, configs.params, params));

              case 5:
                result = _context.sent;
                return _context.abrupt("return", result.data);

              case 9:
                _context.prev = 9;
                _context.t0 = _context["catch"](1);

                if (!(isForbidden(_context.t0) || retry < 1)) {
                  _context.next = 13;
                  break;
                }

                throw _context.t0;

              case 13:
                _context.next = 15;
                return new Promise(function (r) {
                  return setTimeout(r, (0, _random2.default)(1500, 500));
                });

              case 15:
                return _context.abrupt("return", this.request(params, retry - 1));

              case 16:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[1, 9]]);
      }));

      function request(_x) {
        return _request.apply(this, arguments);
      }

      return request;
    }()
  }, {
    key: "signIn",
    value: function () {
      var _signIn = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2(params) {
        var result;
        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.prev = 0;
                _context2.next = 3;
                return this.request(_objectSpread({
                  method: "signIn"
                }, params));

              case 3:
                result = _context2.sent;

                if (!result.isUnfamiliar) {
                  _context2.next = 6;
                  break;
                }

                return _context2.abrupt("return", result);

              case 6:
                _ApolloToken.default.apply(result);

                _ApolloListener.default.emit(events.signInResolve, result);

                return _context2.abrupt("return", result);

              case 11:
                _context2.prev = 11;
                _context2.t0 = _context2["catch"](0);

                _ApolloListener.default.emit(events.signInReject, {
                  error: _context2.t0
                });

                throw _context2.t0;

              case 15:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this, [[0, 11]]);
      }));

      function signIn(_x2) {
        return _signIn.apply(this, arguments);
      }

      return signIn;
    }()
  }, {
    key: "signOut",
    value: function () {
      var _signOut = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee3(params) {
        var result;
        return _regenerator.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.prev = 0;
                _context3.next = 3;
                return this.request(_objectSpread({
                  method: "signOut"
                }, params));

              case 3:
                result = _context3.sent;

                _ApolloListener.default.emit(events.signOutResolve, result);

                return _context3.abrupt("return", result);

              case 8:
                _context3.prev = 8;
                _context3.t0 = _context3["catch"](0);

                _ApolloListener.default.emit(events.signOutReject, {
                  error: _context3.t0
                });

                throw _context3.t0;

              case 12:
                _context3.prev = 12;

                _ApolloToken.default.apply({
                  accessToken: "",
                  refreshToken: ""
                });

                return _context3.finish(12);

              case 15:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this, [[0, 8, 12, 15]]);
      }));

      function signOut(_x3) {
        return _signOut.apply(this, arguments);
      }

      return signOut;
    }()
  }, {
    key: "changeViewer",
    value: function () {
      var _changeViewer = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee4() {
        var result,
            _args4 = arguments;
        return _regenerator.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.prev = 0;
                _context4.next = 3;
                return this.renew.apply(this, _args4);

              case 3:
                result = _context4.sent;

                _ApolloToken.default.apply(result);

                _ApolloListener.default.emit(events.changeViewerResolve, result);

                return _context4.abrupt("return", result);

              case 9:
                _context4.prev = 9;
                _context4.t0 = _context4["catch"](0);

                _ApolloListener.default.emit(events.changeViewerReject, {
                  error: _context4.t0
                });

                throw _context4.t0;

              case 13:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this, [[0, 9]]);
      }));

      function changeViewer() {
        return _changeViewer.apply(this, arguments);
      }

      return changeViewer;
    }()
  }, {
    key: "renew",
    value: function () {
      var _renew = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee5(params) {
        var refreshToken, result;
        return _regenerator.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                refreshToken = _ApolloToken.default.refreshToken;
                (0, _assertResult2.default)(refreshToken, new Error("refreshToken is null"));
                _context5.prev = 2;
                _context5.next = 5;
                return this.request(_objectSpread({
                  method: "renew",
                  refreshToken: refreshToken
                }, params));

              case 5:
                result = _context5.sent;

                _ApolloToken.default.apply(result);

                _ApolloListener.default.emit(events.renewResolve, result);

                return _context5.abrupt("return", result);

              case 11:
                _context5.prev = 11;
                _context5.t0 = _context5["catch"](2);

                _ApolloToken.default.apply({
                  accessToken: "",
                  refreshToken: ""
                });

                _ApolloListener.default.emit(events.renewReject, {
                  error: _context5.t0
                });

                throw _context5.t0;

              case 16:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this, [[2, 11]]);
      }));

      function renew(_x4) {
        return _renew.apply(this, arguments);
      }

      return renew;
    }()
  }]);

  return Authenticator;
}();

exports.default = Authenticator;