"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = initApollo;

var _defaults2 = _interopRequireDefault(require("lodash/defaults"));

require("isomorphic-unfetch");

var _apolloCacheInmemory = require("apollo-cache-inmemory");

var _isBrowser = _interopRequireDefault(require("./isBrowser"));

var _ApolloClient = _interopRequireDefault(require("./ApolloClient"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function create(initialState, options) {
  var configs = (0, _defaults2.default)({}, options);
  var cache = new _apolloCacheInmemory.InMemoryCache(configs.cache).restore(initialState);
  return new _ApolloClient.default(_objectSpread({}, configs, {
    cache: cache
  }));
}

function initApollo(initialState, options) {
  if (!_isBrowser.default) return create(initialState, options);
  if (!initApollo.client) initApollo.client = create(initialState, options);
  return initApollo.client;
}