"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defaults2 = _interopRequireDefault(require("lodash/defaults"));

var _includes2 = _interopRequireDefault(require("lodash/includes"));

var _find2 = _interopRequireDefault(require("lodash/find"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _apolloLinkRetry = require("apollo-link-retry");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var retries = ["INTERNAL_SERVER_ERROR"];

var _default =
/*#__PURE__*/
function (_RetryLink) {
  _inherits(_default, _RetryLink);

  function _default(options) {
    _classCallCheck(this, _default);

    var retryIf = function retryIf(_ref) {
      var result = _ref.result;
      var errors = (0, _get2.default)(result, ["errors"], []);
      var isServerError = (0, _find2.default)(errors, function (_ref2) {
        var extensions = _ref2.extensions;
        return (0, _includes2.default)(retries, extensions.code);
      });
      return Boolean(isServerError);
    };

    var delay = {
      initial: 300,
      max: 3000,
      jitter: true
    };
    var attempts = (0, _defaults2.default)({}, options, {
      max: 5,
      retryIf: retryIf
    });
    return _possibleConstructorReturn(this, _getPrototypeOf(_default).call(this, {
      delay: delay,
      attempts: attempts
    }));
  }

  return _default;
}(_apolloLinkRetry.RetryLink);

exports.default = _default;