"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _assertResult2 = _interopRequireDefault(require("thelper/assertResult"));

var _forEach2 = _interopRequireDefault(require("lodash/forEach"));

var _defaults3 = _interopRequireDefault(require("lodash/defaults"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _wrapDisplayName = _interopRequireDefault(require("recompose/wrapDisplayName"));

var _withConsumer = _interopRequireDefault(require("./withConsumer"));

var _ApolloListener = _interopRequireDefault(require("./ApolloListener"));

var _ApolloToken = _interopRequireDefault(require("./ApolloToken"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _default = function _default(redirect, options) {
  var _defaults2 = (0, _defaults3.default)({}, options),
      disabled = _defaults2.disabled;

  (0, _assertResult2.default)(redirect, new TypeError("redirect is required"));

  var redirectTo = function redirectTo() {
    window.location = redirect;
  };

  return function (Component) {
    var _withAuthorized;

    var withAuthorized =
    /*#__PURE__*/
    function (_React$Component) {
      _inherits(withAuthorized, _React$Component);

      function withAuthorized(props) {
        var _this;

        _classCallCheck(this, withAuthorized);

        _this = _possibleConstructorReturn(this, _getPrototypeOf(withAuthorized).call(this, props));
        var authorized = disabled || _ApolloToken.default.expired > Date.now();
        _this.state = {
          authorized: authorized
        };
        return _this;
      }

      _createClass(withAuthorized, [{
        key: "componentDidMount",
        value: function componentDidMount() {
          var authorized = this.state.authorized;
          this.listeners = [_ApolloListener.default.on("renewRejected", redirectTo), _ApolloListener.default.on("signOut", redirectTo)];
          if (!authorized) this.renewAuthorized();
        }
      }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          (0, _forEach2.default)(this.listeners, function (unListener) {
            return unListener();
          });
        }
      }, {
        key: "renewAuthorized",
        value: function () {
          var _renewAuthorized = _asyncToGenerator(
          /*#__PURE__*/
          _regenerator.default.mark(function _callee() {
            var client;
            return _regenerator.default.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    _context.prev = 0;
                    client = this.props.client;

                    if (_ApolloToken.default.refreshToken) {
                      _context.next = 4;
                      break;
                    }

                    throw new Error();

                  case 4:
                    _context.next = 6;
                    return client.renew();

                  case 6:
                    this.setState({
                      authorized: true
                    });
                    _context.next = 12;
                    break;

                  case 9:
                    _context.prev = 9;
                    _context.t0 = _context["catch"](0);
                    redirectTo();

                  case 12:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee, this, [[0, 9]]);
          }));

          function renewAuthorized() {
            return _renewAuthorized.apply(this, arguments);
          }

          return renewAuthorized;
        }()
      }, {
        key: "render",
        value: function render() {
          var authorized = this.state.authorized;

          if (authorized) {
            return _react.default.createElement(Component, this.props);
          }

          return null;
        }
      }]);

      return withAuthorized;
    }(_react.default.Component);

    _defineProperty(withAuthorized, "displayName", (0, _wrapDisplayName.default)(Component, "withAuthorized"));

    _defineProperty(withAuthorized, "propTypes", {
      client: _propTypes.default.shape().isRequired
    });

    return _withAuthorized = withAuthorized, (0, _withConsumer.default)()(_withAuthorized);
  };
};

exports.default = _default;