"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.format = format;
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _setDisplayName2 = _interopRequireDefault(require("recompose/setDisplayName"));

var _withProps2 = _interopRequireDefault(require("recompose/withProps"));

var _compose2 = _interopRequireDefault(require("lodash/fp/compose"));

var _omit2 = _interopRequireDefault(require("lodash/omit"));

var _camelCase2 = _interopRequireDefault(require("lodash/camelCase"));

var _react = _interopRequireDefault(require("react"));

var _reactApollo = require("react-apollo");

var _getFieldName = _interopRequireDefault(require("./helps/getFieldName"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var mutationProps = ["mutation", "variables", "update", "ignoreResults", "optimisticResponse", "refetchQueries", "awaitRefetchQueries", "onCompleted", "onError", "context"];

function format(name, _ref) {
  var _objectSpread3;

  var fieldName = _ref.fieldName,
      result = _ref.result,
      parent = _ref.parent,
      mutate = _ref.mutate;
  var results = parent.results;
  return _objectSpread({}, result, (_objectSpread3 = {}, _defineProperty(_objectSpread3, name, function () {
    var _ref2 = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee(input, options) {
      var _ref3, data;

      return _regenerator.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return mutate(_objectSpread({
                variables: {
                  input: input
                }
              }, options));

            case 2:
              _ref3 = _context.sent;
              data = _ref3.data;
              return _context.abrupt("return", data[fieldName]);

            case 5:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x, _x2) {
      return _ref2.apply(this, arguments);
    };
  }()), _defineProperty(_objectSpread3, "results", _objectSpread({}, results, _defineProperty({}, name, result))), _objectSpread3));
}

var _default = function _default(name, mutation) {
  return function (Component) {
    var fieldName = (0, _getFieldName.default)(name, mutation);
    return (0, _compose2.default)((0, _setDisplayName2.default)((0, _camelCase2.default)(["withMutation", name])), (0, _withProps2.default)(function () {
      var parent = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      return {
        mutation: mutation,
        ignoreResults: false,
        children: function children(mutate) {
          var result = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
          var props = (0, _omit2.default)(parent, mutationProps);
          var apolloProps = format(name, {
            fieldName: fieldName,
            result: result,
            parent: parent,
            mutate: mutate
          });
          return _react.default.createElement(Component, _extends({}, props, apolloProps));
        }
      };
    }))(_reactApollo.Mutation);
  };
};

exports.default = _default;