"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _react = _interopRequireDefault(require("react"));

var _head = _interopRequireDefault(require("next/head"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactApollo = require("react-apollo");

var _thunk = _interopRequireDefault(require("thelper/thunk"));

var _initApollo = _interopRequireDefault(require("./initApollo"));

var _isBrowser = _interopRequireDefault(require("./isBrowser"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _default = function _default() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var thunkOption = (0, _thunk.default)(options);
  return function (App) {
    var _class, _temp;

    return _temp = _class =
    /*#__PURE__*/
    function (_React$Component) {
      _inherits(_class, _React$Component);

      _createClass(_class, null, [{
        key: "getInitialProps",
        value: function () {
          var _getInitialProps = _asyncToGenerator(
          /*#__PURE__*/
          _regenerator.default.mark(function _callee() {
            var ctx,
                Component,
                router,
                appProps,
                apolloClient,
                apolloState,
                _args = arguments;
            return _regenerator.default.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    ctx = _args.length > 0 && _args[0] !== undefined ? _args[0] : {};
                    Component = ctx.Component, router = ctx.router;

                    if (!App.getInitialProps) {
                      _context.next = 8;
                      break;
                    }

                    _context.next = 5;
                    return App.getInitialProps(ctx);

                  case 5:
                    _context.t0 = _context.sent;
                    _context.next = 9;
                    break;

                  case 8:
                    _context.t0 = {};

                  case 9:
                    appProps = _context.t0;
                    apolloClient = (0, _initApollo.default)({}, thunkOption(appProps));

                    if (_isBrowser.default) {
                      _context.next = 21;
                      break;
                    }

                    _context.prev = 12;
                    _context.next = 15;
                    return (0, _reactApollo.getDataFromTree)(_react.default.createElement(App, _extends({}, appProps, {
                      Component: Component,
                      router: router,
                      apolloClient: apolloClient
                    })));

                  case 15:
                    _context.next = 20;
                    break;

                  case 17:
                    _context.prev = 17;
                    _context.t1 = _context["catch"](12);
                    console.error('Error while running `getDataFromTree`', _context.t1.message); // eslint-disable-line

                  case 20:
                    _head.default.rewind();

                  case 21:
                    apolloState = apolloClient.cache.extract();
                    return _context.abrupt("return", _objectSpread({}, appProps, {
                      apolloState: apolloState
                    }));

                  case 23:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee, null, [[12, 17]]);
          }));

          function getInitialProps() {
            return _getInitialProps.apply(this, arguments);
          }

          return getInitialProps;
        }()
      }]);

      function _class(props) {
        var _this;

        _classCallCheck(this, _class);

        _this = _possibleConstructorReturn(this, _getPrototypeOf(_class).call(this, props));
        _this.apolloClient = (0, _initApollo.default)(props.apolloState, thunkOption(props));
        return _this;
      }

      _createClass(_class, [{
        key: "render",
        value: function render() {
          return _react.default.createElement(App, _extends({}, this.props, {
            apolloClient: this.apolloClient
          }));
        }
      }]);

      return _class;
    }(_react.default.Component), _defineProperty(_class, "displayName", "withProvider(App)"), _defineProperty(_class, "propTypes", {
      apolloState: _propTypes.default.shape().isRequired
    }), _temp;
  };
};

exports.default = _default;