"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.format = format;
exports.default = void 0;

var _setDisplayName2 = _interopRequireDefault(require("recompose/setDisplayName"));

var _withProps2 = _interopRequireDefault(require("recompose/withProps"));

var _compose2 = _interopRequireDefault(require("lodash/fp/compose"));

var _omit2 = _interopRequireDefault(require("lodash/omit"));

var _camelCase2 = _interopRequireDefault(require("lodash/camelCase"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _react = _interopRequireDefault(require("react"));

var _reactApollo = require("react-apollo");

var _getFieldName = _interopRequireDefault(require("./helps/getFieldName"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var queryProps = ["query", "variables", "pollInterval", "notifyOnNetworkStatusChange", "fetchPolicy", "errorPolicy", "ssr", "displayName", "skip", "onCompleted", "onError", "context", "partialRefetch"];

function format(name, _ref) {
  var _objectSpread3;

  var fieldName = _ref.fieldName,
      result = _ref.result,
      parent = _ref.parent;
  var results = parent.results,
      skip = parent.skip,
      loading = parent.loading;
  return _objectSpread({}, result, (_objectSpread3 = {
    results: _objectSpread({}, results, _defineProperty({}, name, result))
  }, _defineProperty(_objectSpread3, name, (0, _get2.default)(result, ["data", fieldName])), _defineProperty(_objectSpread3, "loading", !skip && result.loading || loading || false), _objectSpread3));
}

var _default = function _default(name, query) {
  return function (Component) {
    var fieldName = (0, _getFieldName.default)(name, query);
    return (0, _compose2.default)((0, _setDisplayName2.default)((0, _camelCase2.default)(["withQuery", name])), (0, _withProps2.default)(function () {
      var parent = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      return {
        query: query,
        children: function children() {
          var result = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
          var props = (0, _omit2.default)(parent, queryProps);
          var apolloProps = format(name, {
            fieldName: fieldName,
            result: result,
            parent: parent
          });
          return _react.default.createElement(Component, _extends({}, props, apolloProps));
        }
      };
    }))(_reactApollo.Query);
  };
};

exports.default = _default;