"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.format = format;
exports.default = void 0;

var _setDisplayName2 = _interopRequireDefault(require("recompose/setDisplayName"));

var _withProps2 = _interopRequireDefault(require("recompose/withProps"));

var _compose2 = _interopRequireDefault(require("lodash/fp/compose"));

var _omit2 = _interopRequireDefault(require("lodash/omit"));

var _camelCase2 = _interopRequireDefault(require("lodash/camelCase"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _react = _interopRequireDefault(require("react"));

var _reactApollo = require("react-apollo");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var subscriptionProps = ["subscription", "variables", "shouldResubscribe", "onSubscriptionData", "fetchPolicy"];

function format(name, result, parent) {
  var _objectSpread3;

  var results = parent.results,
      loading = parent.loading;
  return _objectSpread({}, result, (_objectSpread3 = {
    results: _objectSpread({}, results, _defineProperty({}, name, result))
  }, _defineProperty(_objectSpread3, name, (0, _get2.default)(result, ["data", name])), _defineProperty(_objectSpread3, "loading", result.loading || loading || false), _objectSpread3));
}

var _default = function _default(name, subscription) {
  return function (Component) {
    return (0, _compose2.default)((0, _setDisplayName2.default)((0, _camelCase2.default)(["withSubscription", name])), (0, _withProps2.default)(function (parent) {
      return {
        subscription: subscription,
        children: function children(result) {
          var props = (0, _omit2.default)(parent, subscriptionProps);
          var apolloProps = format(name, result, parent);
          return _react.default.createElement(Component, _extends({}, props, apolloProps));
        }
      };
    }))(_reactApollo.Subscription);
  };
};

exports.default = _default;