"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _setDisplayName2 = _interopRequireDefault(require("recompose/setDisplayName"));

var _withProps2 = _interopRequireDefault(require("recompose/withProps"));

var _assertResult2 = _interopRequireDefault(require("thelper/assertResult"));

var _compose2 = _interopRequireDefault(require("lodash/fp/compose"));

var _camelCase2 = _interopRequireDefault(require("lodash/camelCase"));

var _inRange2 = _interopRequireDefault(require("lodash/inRange"));

var _forEach2 = _interopRequireDefault(require("lodash/forEach"));

var _withMutation = _interopRequireDefault(require("./withMutation"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function upload(file, _ref) {
  var uri = _ref.uri,
      data = _ref.data,
      progress = _ref.progress;
  (0, _assertResult2.default)(uri, new TypeError("uri is required"));
  var form = new FormData();
  (0, _forEach2.default)(data, function (value, name) {
    return form.append(name, value);
  });
  form.append("file", file);
  return new Promise(function (resolve, reject) {
    var onprogress = function onprogress(event) {
      if (event.lengthComputable && progress) {
        progress(event.loaded / event.total);
      }
    };

    var xhr = new XMLHttpRequest();
    xhr.open("POST", uri);
    xhr.upload.onprogress = onprogress;
    xhr.onprogress = onprogress;

    xhr.onload = function () {
      if ((0, _inRange2.default)(xhr.status, 200, 300)) {
        resolve(JSON.parse(xhr.response));
        return;
      }

      reject(new Error("failed to upload: server error"));
    };

    xhr.onerror = function () {
      return reject(new Error("failed to upload: network error"));
    };

    xhr.send(form);
  });
}

var _default = function _default(name, mutation, configs) {
  return (0, _compose2.default)((0, _setDisplayName2.default)((0, _camelCase2.default)(["withUploader", name])), (0, _withMutation.default)(name, mutation), (0, _withProps2.default)(function (_ref2) {
    var mutate = _ref2[name];
    return _defineProperty({}, name, function () {
      var _ref4 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(file) {
        var _ref3,
            input,
            progress,
            options,
            settings,
            data,
            _args = arguments;

        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _ref3 = _args.length > 1 && _args[1] !== undefined ? _args[1] : {};
                input = _ref3.input, progress = _ref3.progress, options = _objectWithoutProperties(_ref3, ["input", "progress"]);
                settings = _objectSpread({}, configs, options);
                _context.next = 5;
                return mutate(input, settings);

              case 5:
                data = _context.sent;
                return _context.abrupt("return", upload(file, _objectSpread({}, settings, {
                  data: data,
                  progress: progress
                })));

              case 7:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref4.apply(this, arguments);
      };
    }());
  }));
};

exports.default = _default;