"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = builder;
exports.execFile = execFile;

var _set = _interopRequireDefault(require("lodash/set"));

var _get = _interopRequireDefault(require("lodash/get"));

var _filter = _interopRequireDefault(require("lodash/filter"));

var _graphql = require("graphql");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function builder(schema) {
  return (0, _graphql.graphql)(schema, "{ __schema { types { kind name possibleTypes { name } } } }").then(function (_ref) {
    var data = _ref.data;
    var types = (0, _filter.default)((0, _get.default)(data, ["__schema", "types"]), function (_ref2) {
      var possibleTypes = _ref2.possibleTypes;
      return possibleTypes !== null;
    });
    (0, _set.default)(data, ["__schema", "types"], types);
    return JSON.stringify(data);
  });
}

function execFile(schema) {
  return builder(schema).then(function (data) {
    return data.replace(/"([_\w]+)":/gi, function () {
      return " ".concat(arguments.length <= 1 ? undefined : arguments[1], ": ");
    }).replace(/"([_\w]+)"/gi, function () {
      return "'".concat(arguments.length <= 1 ? undefined : arguments[1], "'");
    }).replace(/([^ ])}/gi, function () {
      return "".concat(arguments.length <= 1 ? undefined : arguments[1], " }");
    }).replace(/([^ ])}/gi, function () {
      return "".concat(arguments.length <= 1 ? undefined : arguments[1], " }");
    }).replace(/,([^ ])/gi, function () {
      return ", ".concat(arguments.length <= 1 ? undefined : arguments[1]);
    });
  }).then(function (data) {
    return "export default ".concat(data, ";\n");
  });
}