import _ from "lodash";

const listeners = [];

export default {
  on(topic, subscriber) {
    const listener = { topic, subscriber };
    listeners.push(listener);
    return () => listeners.pop(listener);
  },
  emit(topic, data) {
    listeners.forEach(listener => {
      if (_.indexOf(topic, listener.topic) < 0) return;
      listener.subscriber({ topic: topic[0], ...data });
    });
  },
};
