import localStorage from "./localStorage";

export default {
  get token() {
    const value = localStorage.getItem("apollo-access-token");
    if (value) return `Bearer ${value}`;
    return "";
  },
  set token(value) {
    localStorage.setItem("apollo-access-token", value);
  },
  get refreshToken() {
    return localStorage.getItem("apollo-refresh-token");
  },
  set refreshToken(value) {
    localStorage.setItem("apollo-refresh-token", value);
  },
  get expired() {
    return localStorage.getItem("apollo-expired");
  },
  set expired(value) {
    localStorage.setItem("apollo-expired", value);
  },
  apply({ accessToken, refreshToken }) {
    this.token = accessToken;
    this.refreshToken = refreshToken;
    this.expired = refreshToken ? Date.now() + 55 * 60 * 1000 : 0;
  },
};
