/* eslint-disable react/no-danger */

import _ from "lodash";
import React from "react";
import PropTypes from "prop-types";
import { bs58 } from "./env";

export default class ServerSideEnv extends React.PureComponent {
  static propTypes = {
    allows: PropTypes.arrayOf(PropTypes.string).isRequired,
  };

  render() {
    const { allows } = this.props;
    const env = _.pick(process.env, allows);
    const data = `__ENV__ = "${bs58.encode(Buffer.from(JSON.stringify(env)))}"`;
    return <script dangerouslySetInnerHTML={{ __html: data }} />;
  }
}
