import retry from "async-retry";
import { ClientFunction } from "testcafe";
import { waitForReact, ReactSelector } from "testcafe-react-selectors";

fixture("withAuthorized")
  .page("http://localhost:65530/")
  .beforeEach(t =>
    retry(
      async () => {
        await t.navigateTo("/signin");
        await waitForReact();
      },
      { maxTimeout: 1000 },
    ),
  );

test("withAuthorized", async t => {
  const pathname = ClientFunction(() => document.location.pathname);

  await t
    .typeText("#username", "apollo")
    .click("#signin")
    .expect(pathname())
    .eql("/signout")
    .expect(ReactSelector("ViewerId").innerText)
    .eql("20")
    .click("#changeViewer")
    .expect(ReactSelector("ViewerId").innerText)
    .eql("50")
    .click("#signout")
    .expect(pathname())
    .eql("/signin")
    .navigateTo("/signout")
    .expect(pathname())
    .eql("/signin");
});
