import retry from "async-retry";
import { waitForReact, ReactSelector } from "testcafe-react-selectors";

fixture("withMutation")
  .page("http://localhost:65530/")
  .beforeEach(t =>
    retry(
      async () => {
        await t.navigateTo("/");
        await waitForReact();
      },
      { maxTimeout: 1000 },
    ),
  );

test("withMutation & withQuery", async t => {
  await t
    .click("#refresh")
    .typeText("#input", "Apple")
    .click("#add")
    .click("#refresh")
    .expect(ReactSelector("List").find("li:nth-child(1)").innerText)
    .eql("0 - Apple");
});
