import { format } from "../withMutation";

describe("withMutation", () => {
  it("successfully format", async () => {
    const results = { posts: [{ id: "5" }] };
    const mutate = jest.fn(() => ({ data: { addPost: { id: "20" } } }));
    const props = format("addPost", {
      fieldName: "addPost",
      result: { id: "10" },
      parent: { results },
      mutate,
    });
    expect(props.results.addPost).toEqual({ id: "10" });
    const result = await props.addPost(
      { text: "new" },
      { optimisticResponse: { addPost: { id: "100" } } },
    );
    expect(result).toEqual({ id: "20" });
    expect(mutate).toHaveBeenCalledWith({
      variables: { input: { text: "new" } },
      optimisticResponse: { addPost: { id: "100" } },
    });
    expect(mutate).toHaveBeenCalledTimes(1);
  });
});
