import { format } from "../withQuery";

describe("withQuery", () => {
  it("successfully format", async () => {
    const results = { users: { data: { users: [{ id: "5" }] } } };
    const props = format("posts", {
      fieldName: "posts",
      result: { data: { posts: [{ id: "10" }] } },
      parent: { results, loading: true },
    });
    expect(props).toMatchSnapshot();
    expect(props.posts).toEqual([{ id: "10" }]);
    expect(props.loading).toBe(true);
  });

  it("successfully when loading is false", async () => {
    const results = { users: { data: { users: [{ id: "5" }] } } };
    const props = format("posts", {
      fieldName: "posts",
      result: { data: { posts: [{ id: "10" }], loading: true } },
      parent: { results, skip: true },
    });
    expect(props).toMatchSnapshot();
    expect(props.loading).toBe(false);
  });
});
