import retry from "async-retry";
import { waitForReact, ReactSelector } from "testcafe-react-selectors";

fixture("withSubscription")
  .page("http://localhost:65530/")
  .beforeEach(t =>
    retry(
      async () => {
        await t.navigateTo("/");
        await waitForReact();
      },
      { maxTimeout: 1000 },
    ),
  );

test("withSubscription", async t => {
  await t
    .click("#refresh")
    .click("#autoRefetch")
    .typeText("#input", "Banana")
    .click("#add")
    .expect(ReactSelector("List").find("li:nth-child(2)").innerText)
    .eql("1 - Banana")
    .expect(ReactSelector("Latest").find("span:nth-child(2)").innerText)
    .eql("Banana");
});
