import { format } from "../withSubscription";

describe("withSubscription", () => {
  it("successfully format", async () => {
    const results = { users: { data: { users: [{ id: "5" }] } } };
    const props = format(
      "onAdd",
      { data: { onAdd: [{ id: "10" }] } },
      { results, loading: true },
    );
    expect(props).toMatchSnapshot();
    expect(props.onAdd).toEqual([{ id: "10" }]);
    expect(props.loading).toBe(true);
  });

  it("successfully when loading is false", async () => {
    const results = { users: { data: { users: [{ id: "5" }] } } };
    const props = format(
      "onAdd",
      { data: { posts: [{ id: "10" }] } },
      { results, skip: true },
    );
    expect(props).toMatchSnapshot();
    expect(props.loading).toBe(false);
  });
});
