import retry from "async-retry";
import { waitForReact, ReactSelector } from "testcafe-react-selectors";

fixture("withUploader")
  .page("http://localhost:65530/")
  .beforeEach(t =>
    retry(
      async () => {
        await t.navigateTo("/uploader");
        await waitForReact();
      },
      { maxTimeout: 1000 },
    ),
  );

test("withUploader", async t => {
  await t
    .typeText("#input", "EVAAIR")
    .setFilesToUpload("#file", `${__dirname}/../__mocks__/sample.png`)
    .click("#upload")
    .wait(100)
    .expect(ReactSelector("Report").innerText)
    .eql(
      `report: {"ciphertext":"EVAAIR","fieldname":"file","filename":"sample.png"}`,
    );
});
