import "isomorphic-unfetch";
import _ from "lodash";
import { InMemoryCache } from "apollo-cache-inmemory";
import isBrowser from "./isBrowser";
import ApolloClient from "./ApolloClient";

function create(initialState, options) {
  const configs = _.defaults({}, options);

  const cache = new InMemoryCache(configs.cache).restore(initialState);

  return new ApolloClient({ ...configs, cache });
}

export default function initApollo(initialState, options) {
  if (!isBrowser) return create(initialState, options);
  if (!initApollo.client) initApollo.client = create(initialState, options);
  return initApollo.client;
}
