import _ from "lodash";
import URL from "url-parse";
import { BatchHttpLink } from "apollo-link-batch-http";
import ApolloToken from "../ApolloToken";

export default class extends BatchHttpLink {
  constructor(options) {
    const { uri, path, ...configs } = _.defaults({}, options, {
      path: "/graphql",
      credentials: "same-origin",
    });
    const url = new URL(uri);
    super({ uri: `${url.origin}${path}`, ...configs });
    this.configs = configs;
  }

  request(operation, forward) {
    const { configs } = this;
    operation.setContext(({ headers }) => ({
      headers: {
        ...headers,
        ...configs.headers,
        authorization: ApolloToken.token,
      },
    }));
    return super.request(operation, forward);
  }
}
