import _ from "lodash";
import { RetryLink } from "apollo-link-retry";

const retries = ["INTERNAL_SERVER_ERROR"];

export default class extends RetryLink {
  constructor(options) {
    const retryIf = ({ result }) => {
      const errors = _.get(result, ["errors"], []);
      const isServerError = _.find(errors, ({ extensions }) =>
        _.includes(retries, extensions.code),
      );
      return Boolean(isServerError);
    };
    const delay = { initial: 300, max: 3000, jitter: true };
    const attempts = _.defaults({}, options, { max: 5, retryIf });
    super({ delay, attempts });
  }
}
