import _ from "lodash";
import URL from "url-parse";
import { WebSocketLink } from "apollo-link-ws";
import ApolloToken from "../ApolloToken";

export default class extends WebSocketLink {
  constructor(options) {
    const { uri, path, webSocketImpl, ...configs } = _.defaults({}, options, {
      path: "/graphql",
      credentials: "same-origin",
    });
    const url = new URL(uri);
    super({
      uri: `${_.replace(url.origin, /^http/i, "ws")}${path}`,
      options: {
        connectionParams: () => ({ authorization: ApolloToken.token }),
        ...configs,
      },
      webSocketImpl,
    });
  }
}
