import _ from "lodash";
import fp from "lodash/fp";
import { withPropsOnChange, setDisplayName } from "recompose";
import withQuery from "./withQuery";

export function format(name, props) {
  const { [name]: result } = props;

  return {
    totalCount: _.get(result, ["totalCount"], 0),
    [name]: _.get(result, ["nodes"], []),
  };
}

export default (name, query) => Component =>
  fp.compose(
    setDisplayName(_.camelCase(["withOffsetPagination", name])),
    withQuery(name, query),
    withPropsOnChange([name], props => format(name, props)),
  )(Component);
