import fs from "fs";
import { JsonWebToken } from "..";

describe("jwt", () => {
  it("is required", () => {
    expect(() => new JsonWebToken()).toThrow(
      new TypeError("keys least one is required"),
    );
  });

  it("use single key", async () => {
    const jwt = new JsonWebToken({
      private: fs.readFileSync(`${__dirname}/../../../__mocks__/private.pem`),
    });
    expect(jwt).toMatchSnapshot();
    const data = jwt.verify(jwt.sign({ id: "10" }));
    expect(data.id).toBe("10");
  });

  it("use multiple key", async () => {
    const jwt = new JsonWebToken({
      private: fs.readFileSync(`${__dirname}/../../../__mocks__/private.pem`),
      public: fs.readFileSync(`${__dirname}/../../../__mocks__/public.pem`),
    });
    expect(jwt).toMatchSnapshot();
    const data = jwt.verify(jwt.sign({ id: "10", acr: "NONO" }, "private"));
    expect(data.id).toBe("10");
  });
});
